Index: trunk/SophyaLib/Manual/perfmachine.txt
===================================================================
--- trunk/SophyaLib/Manual/perfmachine.txt	(revision 3259)
+++ trunk/SophyaLib/Manual/perfmachine.txt	(revision 3266)
@@ -75,5 +75,5 @@
 ----------------------------------------------------------------------------------------------
 (a)xeon-lx-2.4GHz    | 1290   |   53      53       55    |    338       340       320
-(a)xeon-lx-2.8GHzicc | 2040   |   85      80       83    |    914       409       914
+(b)xeon-lx-2.8GHzicc | 2040   |   85      80       83    |    914       409       914
 (c)amd-lx            | 1560   |   65      77       68    |    666       314       686 
 (cc)amd2-lx          |        |
@@ -87,6 +87,8 @@
 (j)xeon-osx            
 
-(p)ibm-aix-regatta   | 3100   |  130      55      133    |    730       115      1750
-(p)ibm-aix-meso      | 3600   |  150      75      150    |   1480       203      3600
+(p)ibm-aix-regatta   | 3100   |  130      55      133    |    730       115      1750  (32 bits)
+(p)ibm-aix-meso      | 5700   |  240      70      320    |   1500       220      3400  (32 bits)
+
+(s)sgi-magique       |  336   |  14       7       15     |    340        40       460  (32 bits)  
 ----------------------------------------------------------------------------------------------
 
@@ -99,7 +101,7 @@
     -> MDBLOPS (puissance de calcul sur float)
 (3) int, cpupowerI 0 3000000 5 / cpupowerI 2
-    -> MINTOPS  (puissance de calcul sur int)
+    -> MINTOPS  (puissance de calcul sur int=4 bytes)
 (4) long (ou long long (*)) cpupowerL 0 3000000 5 / cpupowerL 2
-    -> MLONOPS  (puissance de calcul sur long)
+    -> MLONOPS  (puissance de calcul sur long=8 bytes)
 ----------------------------------------------------------------------------------------------
         MFLOPS       |   (1)MFLOPS       (2)MDBLOPS       (3)MINTOPS       (4)MLONOPS 
@@ -119,25 +121,26 @@
 
 (p)ibm-aix-regatta   | 
-(p)ibm-aix-meso      |    250/628         160/1260          240/1120        
+(p)ibm-aix-meso      |    250/1150        250/1500          250/1200        50/200     (32 bits)
+                     |    280/1500        250/1600          250/1100        210/1000   (64 bits -q64)
+
+(s)sgi-magique       |  
 ----------------------------------------------------------------------------------------------
 
 X.3/  Comparaison avec SPEC 
-csh>  cpupower 2 
+csh>  cpupower 0 / cpupower 2 
 ----------------------------------------------------------------------
                          MFLOPS(1)      SPECfp      SPECint 
 ----------------------------------------------------------------------
-(b)xeon-lx-2.8GHz         900            1400        1400
-(c)amd-lx                 690            1600        1300
+(b)xeon-lx-2.8GHz         166/900        1400        1400
+(c)amd-lx                 125/690        1600        1300
 (cc)amd2-lx               675            1600        1300
 
-(e)osf-xp1000             648             500         400
-(f)superosf               842            1100         700
-
-(f)G4-osx-1.25GHz      92/380                                 (-g)/(-O2 -g)
-(i)core-osx-1.83GHz    310/880            1400        1500    (-g)/(-O2 -g)
-(j)xeon-osx              2600            2900          -
-
-(p)ibm-aix-regatta    730/1750           1050         700     (-O -g)/(-O3)
-(p)ibm-aix-meso      1250/3600                                (-O -g)/(-O3)
+(e)osf-xp1000             32/650         500         400
+(f)superosf               842            1100        700
+
+(i)core-osx-1.83GHz       110/850        1400        1500    
+(j)xeon-osx               2600           2900          -
+
+(p)ibm-aix-regatta        130/700        1050        700     
 ----------------------------------------------------------------------
 
@@ -187,6 +190,76 @@
 B/ Calcul brut (Tableaux de SOPHYA) avec / sans threads
 --------------------------------------------------------
-
-B.1/ Version corrige de zthr.cc (apres 23/05/07) 
+B.1.a/   Calcul sur vecteur 10 * V2 ~= DLO4 (V1) 
+         ~ 10 x 10 x 9. 10^6 operations double sur 2 x  9 10^6 double    
+         900 M.Ops r_8 / ~ 1500 MO 
+
+(1) time cpupower 0     # compile avec -O  (/ -O -g)
+(2) time zthr arrdl 1 3000   1 thread
+(3) time zthr arrdl 2 3000   2 thread
+(4) time zthr arrdl 4 3000   4 thread
+(5) time zthr arrdl 6 3000   6 thread
+(6) time zthr arrdl 8 3000   8 thread
+
+-----------------------------------------------------------------------------------
+                     (1)MFLOPS  (2)CPU/Elap/%   (3)CPU/Elap/%   (4)CPU/Elap/%
+-----------------------------------------------------------------------------------
+(a)xeon-lx-2.4GHz      53        
+(b)xeon-lx-2.8GHz      65       2.6/2.6/100%    5.3/2.9/180%   14.3/4.86/310% 
+                                   (5) 23/7.4/314%
+(c)amd-lx              95        
+                                 
+                                  
+(e')osf-cool           32       5.7/5.8/98%     11.1/11.3/98%   22.3/22.5/98% 
+(f)superosf                    
+
+(g)G5-osx-2GHz         88       2.5/2.6/99%     5.9/3.38/184%    11/6.45/173%    [-O2 -g]
+(h)G4-osx-1.25GHz      25       6.6/7/95%       13.4/13.8/97%                    [-O2 -g]
+(i)core-osx-1.83GHz   107       2.1/2.1/98%     4.3/2.9/150%     8.3/30/31%      [-O2 -g]
+(j)xeon-osx           
+
+(p)ibm-aix-regatta    130        
+(q)ibm-aix-meso       150       0.8/1/81%       2./2./100%       3.6/3/122%   [-O3]
+                                  (5) 5.4/4/140%    (6) 7.7/4/192% 
+
+(s)sgi-magique          7       78/78/99%       167/95/175%      339/96/352%     [-O -g: NON-OPT]
+                       14       16.4/16.5/99%   33.8/22.4/150%   79/32/250%      [-O -g2 OPT]
+ -----------------------------------------------------------------------------------
+
+B.1.b/   Calcul sur vecteur V2 = Sin(V1) + Cos(V1) 
+         ~ 50 x 9. 10^6 operations double sur 2 x  9 10^6 double, mem ~ 150 MO 
+         ~500 M.Ops r_8 / ~ 600 MO I/O
+
+(1) time cpupower 0     # compile avec -O  (/ -O -g)
+(2) time zthr arrmf 1 3000   1 thread
+(3) time zthr arrmf 2 3000   2 thread
+(4) time zthr arrmf 4 3000   4 thread
+(5) time zthr arrmf 6 3000   6 thread
+(6) time zthr arrmf 8 3000   8 thread
+
+-----------------------------------------------------------------------------------
+                     (1)MFLOPS  (2)CPU/Elap/%   (3)CPU/Elap/%   (4)CPU/Elap/%
+-----------------------------------------------------------------------------------
+(a)xeon-lx-2.4GHz      53        
+(b)xeon-lx-2.8GHz      65       1.7/1.7/100%    3.5/2.1/173%     9.8/3.6/275%
+(c)amd-lx              95        
+                                 
+(e')osf-cool           32       4.2/4.3/98%     8.2/8.4/98%      16.1/16.2/98%
+(f)superosf                    
+
+(g)G5-osx-2GHz         88       2.3/2.3/100%      5/3/165%        9.6/5.8/167%  [-O2 -g]
+(h)G4-osx-1.25GHz      25       4.5/4.8/95%       10.9/14.6/72%        [-O2 -g]
+(i)core-osx-1.83GHz   107       2.3/2.3/98%       4.8/3.1/158%                [-O2 -g]
+(j)xeon-osx           
+
+(p)ibm-aix-regatta    130        
+(q)ibm-aix-meso       150       1.7/2/87%         2.6/3/86%       5.4/5.4/100%   [-O3]
+                                     (5) 9/6/150%    (6) 11.5/15/76% 
+
+(s)sgi-magique         7       11.5/11.7/99%     24/17/140%      51.5/18.4/280%  [-O -g NON-OPT]
+                      14       6.5/6.6/99%       13.3/12/110%    34.5/17.3/200%  [-O -g3 OPT]
+ -----------------------------------------------------------------------------------
+
+
+B.1.c/ Version corrige de zthr.cc (apres 23/05/07) 
          arr = (c1*a1) + (c2*a2) 
          ~ 3 x 4. 10^6 operations int_4 sur 3 x 4 10^6 int_4    
@@ -213,5 +286,4 @@
 
 
-(d)osf-asc                     
                                   
 (e')osf-cool           32        0.43/1.2/35%   0.6/1.33/44%     1.1/1.3/82%      [-O -g]
@@ -234,9 +306,7 @@
                                      (5) 2.4/1.2/193%   (6) 4.25/1.6/265%      
 
-
-(s)sgi-magique         460        
- -----------------------------------------------------------------------------------
-
-B.1.bis/ ancienne version de zthr (avant 23/05/07) 
+ -----------------------------------------------------------------------------------
+
+B.1.x/ ancienne version de zthr (avant 23/05/07) 
          On faisait 2 multiplications par ctye suivi d'un produit matriciel !
          arr = c1*a1*c2*a2   ( ~ 3 10^6 op. double)
@@ -367,5 +437,5 @@
                                            (6) 29.9/6.74/442%
 
-(s)sgi-magique         460        49/49/99%                  101/56/181%
+(s)sgi-magique         400        44/44.3/99%                96.5/55/176%
 
  -----------------------------------------------------------------------------------
@@ -432,4 +502,6 @@
 
 (q)ibm-aix-meso             0.43       0.27        0.52      1.12/0.75       0.35  
+
+(s)sgi-magique              2.45       1.9         5.65      7.45/6.3        2.8  (-O -g3)
 -----------------------------------------------------------------------------------
 
@@ -505,4 +577,5 @@
 (q)ibm-aix-meso            0.55/~100%
 
+(s)sgi-magique             5.3/~90%
 --------------------------------------------------------------------------------------------
 