Index: /trunk/SophyaLib/Manual/modifs.tex
===================================================================
--- /trunk/SophyaLib/Manual/modifs.tex	(revision 3269)
+++ /trunk/SophyaLib/Manual/modifs.tex	(revision 3270)
@@ -159,4 +159,9 @@
 \titre{PI/piapp}
 \begin{itemize}
+\item[\rond]  Juin 2007 {\bf (PI/PIext)}:  Ajout des mthodes 
+{\tt PIGraphicAtt::ColNameToColor() , ColIndexToColor()} et possibilit d'utiliser le contenu
+d'une colonne d'une table comme nom de couleur ou numro de couleur pour le trac
+des markers par PINTuple {\tt PINTuple::SelectColorByName() , SelectColorByIndex()}.
+Ajout des commandes {\bf nt2dcn} et {\bf nt2dci} ds piapp. 
 \item[\rond]  Avril 2007 {\bf (PI)}:  La source des problmes sur MacOS/PowerPC (G4/G5)
 et AIX (architecture Power) a finalement t identifi et corrig/
Index: /trunk/SophyaLib/Manual/perfmachine.txt
===================================================================
--- /trunk/SophyaLib/Manual/perfmachine.txt	(revision 3269)
+++ /trunk/SophyaLib/Manual/perfmachine.txt	(revision 3270)
@@ -219,6 +219,6 @@
 
 (p)ibm-aix-regatta    130        
-(q)ibm-aix-meso       150       0.8/1/81%       2./2./100%       3.6/3/122%   [-O3]
-                                  (5) 5.4/4/140%    (6) 7.7/4/192% 
+(q)ibm-aix-meso       150       0.7/1/70%       1.2/2./60%       3.2/2/150%   [-O3]
+                                  (5) 5.4/3/180%    (6) 6.4/3/210% 
 
 (s)sgi-magique          7       78/78/99%       167/95/175%      339/96/352%     [-O -g: NON-OPT]
@@ -253,6 +253,6 @@
 
 (p)ibm-aix-regatta    130        
-(q)ibm-aix-meso       150       1.7/2/87%         2.6/3/86%       5.4/5.4/100%   [-O3]
-                                     (5) 9/6/150%    (6) 11.5/15/76% 
+(q)ibm-aix-meso       150       1./2/50%         2.8/3/86%       5.4/4/130%   [-O3]
+                                     (5) 10/4/250%    (6) 11.2/5/220%% 
 
 (s)sgi-magique         7       11.5/11.7/99%     24/17/140%      51.5/18.4/280%  [-O -g NON-OPT]
@@ -391,4 +391,6 @@
 (b)xeon-lx-2.8GHz      920        3.4/3.4/100%               12/6.1/199%
                                            (4) 55.8/14/400%
+                                           (5) 79.5/20.3/392%
+                                           (6) 102/25.8/396%
 (c)amd-lx              690        6.98/6.98/100%             14.1/8.15/173%
                                            (4) 27.7/14.23/194%
@@ -407,4 +409,6 @@
                                            (5) 80.6/81/99.6%
                                            (6) 107.8/108.3/99.5%
+(e')osf-cool                      13/13.22/98%               26/26.1/99%
+                                           (4) 51.8/51.9/99%
 (f)superosf            842        6.1/7.24/84%               12.35/6.29/196%
                                            (4) 24.3/6.31/385%
@@ -522,5 +526,9 @@
 (a)xeon-lx-2.4GHz     1167        5.5/5.6/97%        180         7.4/7.4/100%     135    
        -O3 -g                                                    6.8/7.1/96%      147    
-(b)xeon-lx-2.8GHz      920     
+
+(b)xeon-lx-2.8GHz      920        3.6/3.7/98%                    3.7/3.8/99%
+                                                          ~2x    6.5/8.8/73%
+                                                          ~4x    8/14/55%   (15 sec elapsed)
+         
 (c)amd-lx              690        3.2/3.75/86%                   4.2/4.2/100%     238
                                                             ~2x  4.7/4.7/99%
@@ -529,5 +537,5 @@
 (d)osf-asc             420        13.3/13.9/95.7%     75        12.2/17.6/70%     82
 (e)osf-xp1000          648        9.9/10.2/97%       101        9.3/9.46/98.5%    107     
-(e')cool                                                        9.1/9.3/98%
+(e')cool                          9.2/10.1/91%                  9.1/9.3/98%
 (f)superosf            842        6./6.22/96.7%      166        5.1/5.18/97.4%    196     
 
@@ -547,4 +555,7 @@
 (q)ibm-aix-meso    3600/1250      3.95/4.3/91%       250        3.82/4./94%       260
        2 jobs //                                           ~2x  3.88/4.2/92%      250
+                                  2.8/4.76/59%                  2.1/4.45/47%     [-O3]
+                                                          ~2x   2.5/4.7/54%
+                                                          ~4x   2.5/4.8/55% 
 
 
@@ -562,5 +573,5 @@
 -------------------------------------------------------------------------------------------
 (a)xeon-lx-2.4GHz          5.6/~100%    
-(b)xeon-lx-2.8GHz 
+(b)xeon-lx-2.8GHz          5.34/~90%
 (c)amd-lx                  5.5/5.5/99%      
 
@@ -633,5 +644,7 @@
 -------------------------------------------------------------------------------------------
 (a)xeon-lx-2.4GHz          17/26/63%       5.5/5.6/94%        
-(b)xeon-lx-2.8GHz 
+
+(b)xeon-lx-2.8GHz          7/18.5/40%      2.7/2.8/100%                                   7000000
+
 (c)amd-lx                  5.9/6./97%      3.4/3.4/100%      30/32/93%      24/165/13% ?
 
@@ -647,5 +660,10 @@
 (p)ibm-aix-regatta        
 (q)ibm-aix-meso           5.5/16.8/38%    5.7/13.2/43%      32.7/85/39%    29/60/49%
-
+                          6/11/55%        4/9/44%
+                          6.3/10.6/60%    4/6/64%
+   2 lecture //                    ~2x  4/6/60% Elapsed 7 sec
+   1 write + 2 read //    6.3/10.4/60%  ~2 3.8/6.4/59%  Elapsed < 11 sec                
+   1 write + 3 read //                                 19 sec
+   4 read //                                           6 sec
 --------------------------------------------------------------------------------------------
 