Index: trunk/SophyaLib/Manual/perfmachine.txt
===================================================================
--- trunk/SophyaLib/Manual/perfmachine.txt	(revision 3270)
+++ trunk/SophyaLib/Manual/perfmachine.txt	(revision 3273)
@@ -8,4 +8,6 @@
 (b) ccali : Bipro-bicoeur Xeon@2.8 GHz Linux (xeon-lx-2.8GHz)  , icc 8.0 ou 9.0
      Flags de compilation avec [-O -g]      
+(bb) grid49 : Bipro-bicoeur nouveau Xeon 5140 @ 2.33 GHz
+(bb4) grid50 : Bipro-quadri-coeur nouveau Xeon E5345 @ 2.33 GHz --> 8 coeurs
 (c) sgsda: AMD Bipro AMD opteron 248 @ 2.2 GHz (amd-lx-
      Flags de compilation avec [-O -g]      
@@ -76,4 +78,6 @@
 (a)xeon-lx-2.4GHz    | 1290   |   53      53       55    |    338       340       320
 (b)xeon-lx-2.8GHzicc | 2040   |   85      80       83    |    914       409       914
+(bb)n-xeon-grid49    | 3000   |   125     85       130   |    660       500       660
+(bb)n-xeon4c-grid50  | 2568   |   107     103      109   |    655       500       655
 (c)amd-lx            | 1560   |   65      77       68    |    666       314       686 
 (cc)amd2-lx          |        |
@@ -108,5 +112,7 @@
 ----------------------------------------------------------------------------------------------
 (a)xeon-lx-2.4GHz    | 
-(a)xeon-lx-2.8GHzicc |    166/905         90/900           166/1500         88/522    (*)
+(b)xeon-lx-2.8GHzicc |    166/905         90/900           166/1500         88/522    (*)
+(bb)nxeon-grid49     |    250/1030        125/660          250/2500         125/2280
+(bb4)xeon-4c-grid50  |    207/1019        110/660          207/2460         107/2285
 (c)amd-lx            |    125/695         65/675           125/1570         65/1045
 (cc)amd2-lx          | 
@@ -205,6 +211,10 @@
 -----------------------------------------------------------------------------------
 (a)xeon-lx-2.4GHz      53        
-(b)xeon-lx-2.8GHz      65       2.6/2.6/100%    5.3/2.9/180%   14.3/4.86/310% 
+(b)xeon-lx-2.8GHz      85       2.6/2.6/100%    5.3/2.9/180%   14.3/4.86/310% 
                                    (5) 23/7.4/314%
+(bb)nxeon-grid49       125      2/2/99%         4/2/186%       8/2.45/326%
+                                   (5) 12/3.6/330%   (6) 16/4.7/340%
+(bb4)xeon-4c-grid50    110      2.2/2.2/99%     4.2/2.3/185%   8/2.5/321%
+                                   (5) 13/3.1/470%   (6) 21/3.8/544%
 (c)amd-lx              95        
                                  
@@ -241,5 +251,8 @@
 -----------------------------------------------------------------------------------
 (a)xeon-lx-2.4GHz      53        
-(b)xeon-lx-2.8GHz      65       1.7/1.7/100%    3.5/2.1/173%     9.8/3.6/275%
+(b)xeon-lx-2.8GHz      85       1.7/1.7/100%    3.5/2.1/173%     9.8/3.6/275%
+                                   (5) 12/3.6/330%    (6) 16/4.7/340%
+(bb)nxeon-grid49       125      1.6/1.6/100%    3.2/1.7/183%     6.7/2.1/314% 
+                                   (5) 10.1/3.2/320%  (6) 14.4/4.05/330%
 (c)amd-lx              95        
                                  
@@ -393,4 +406,12 @@
                                            (5) 79.5/20.3/392%
                                            (6) 102/25.8/396%
+(bb)nxeon-grid49       660        4.3/4.3/100%               9.3/4.7/200%
+                                           (4) 28.8/7.3/390%
+                                           (5) 41/10.4/393%
+                                           (6) 57.5/14.45/397%
+(bb4)xeon-4c-grid50    660        4.7/4.7/100%               10.7/5.15/199%
+                                           (4) 27.8/7.1/391%
+                                           (5) 57.4/10.6/540%
+                                           (6) 129/16.8/776%
 (c)amd-lx              690        6.98/6.98/100%             14.1/8.15/173%
                                            (4) 27.7/14.23/194%
@@ -530,4 +551,13 @@
                                                           ~2x    6.5/8.8/73%
                                                           ~4x    8/14/55%   (15 sec elapsed)
+(bb)nxeon-grid49       660                                       3.3/3.3/99% 
+                                                          ~2x    3.3/3.4/100%  (4 sec elapsed)
+                                                          ~4x    4.6/4.6/99%   (5 sec elapsed)
+                                                          ~8x    4.5/4.5/50%   (9 sec elapsed)
+(bb4)xeon-4c-grid50    660                                       3.6/3.6/99% 
+                                                          ~2x    3.6/3.6/100%  (4 sec elapsed)
+                                                          ~4x    4.4/4.4/99%   (5 sec elapsed)
+                                                          ~8x    7.1/7.1/99%   (7  sec elapsed)
+                                                          ~16x   7.1/14.4/50%   (15 sec elapsed)
          
 (c)amd-lx              690        3.2/3.75/86%                   4.2/4.2/100%     238
@@ -607,4 +637,5 @@
       avec -O3 -g 
 (b)xeon-lx-2.8GHz (2)     
+(bb4)xeon-4c-grid50       1/1/96%         1.6/1.2/133%     4.9/4.05/120%     6/5/122%
 (c)amd-lx                 0.6/1/63%        0.6/1/60%       3.5/3.5/102%      2.6/2.7/98% 
 