Index: trunk/SophyaLib/Manual/modifs.tex
===================================================================
--- trunk/SophyaLib/Manual/modifs.tex	(revision 3286)
+++ trunk/SophyaLib/Manual/modifs.tex	(revision 3301)
@@ -41,5 +41,5 @@
 \begin{center}
 {\Large \bf Liste de modifications de SOPHYA } \\[5mm] 
-{\large Janvier 2003 - Juin 2007 } \\[25mm]
+{\large Septembre 2003 - Ao\^{u}t 2007 } \\[25mm]
 Liste des tags et dates : \\[5mm]
 {\large 
@@ -55,5 +55,5 @@
 V = 1.9xx  &   \hspace{10mm}  & 09/2005 ... 09/2006  \\
 V = 2.0  &   \hspace{10mm}  &  Septembre 2006 - tag CVS \\
-V = 2.135  &   \hspace{10mm}  &  Juin 2007 - NO tag  \\
+V = 2.046  &   \hspace{10mm}  &  Ao\^{u}t 2007 - NO tag  \\
 
 \end{tabular}
@@ -75,5 +75,5 @@
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
-\groupe{De V2.0 (Sep2006)  V2.2 (Sep2007 ?) }
+\groupe{De V2.0 (Sep2006)  V2.1 (Sep2007 ?) }
 \titre{BuildMgr} 
 \begin{itemize}
@@ -102,5 +102,8 @@
 \titre{BaseTools} 
 \begin{itemize}
-\item[\rond] Avril 2007 {\bf ThreadSafe } \hspace{5mm}
+\item[\rond] Aout 2007 : Passage numro de version SOPHYA V=2.135 
+ V=2.046 - Les numros V=A.B sont dsormais rservs aux versions 
+avec un tag cvs.
+\item[\rond] Avril 2007 : {\bf ThreadSafe } \hspace{5mm}
 Les oprations de partage de rfrence rendues thread-safe pour les classes 
 {\bf NDataBlock$<$T$>$ , SegDataBlock$<$T$>$, SwSegDataBlock$<$T$>$} 
@@ -150,4 +153,6 @@
 
 \begin{itemize}
+\item[\rond]  Aou 2007 :  Correction de signe dans {\tt LocalMap::PixToSphereC()} suite message de
+S. Plaszczynski du 12/07/07
 \item[\rond]  Fev 2007 :  Ajout methode RenewObjId() (reecriture PPF) pour les cartes spheriques 
 et localmap
@@ -174,4 +179,20 @@
 \titre{PI/piapp}
 \begin{itemize}
+\item[\rond]  Aout 2007 {\bf (PI)}: Nouvelles mthodes de calcul de limite de LUT
+dans PIImage (AutoLut) et ajout du dcodage de l'option {\tt autolut=alt[,ns[,minp,maxp]]}.
+Si {\tt minp,maxp} spcifis, seuls les pixels entre {\tt minp <= pixval <= maxp} 
+sont utiliss pour le calcul des limites.
+\begin{verbatim}
+  autolut=minmax,frac   Fraction de la dynamique totale
+  autolut=meansig,ns   min=mean-ns*sigma , max=mean+ns*sigma
+  autolut=histail,ns   Queue de l'histo des pixels 
+  autolut=hispeak,ns  Pic de l'histo des pixels
+\end{verbatim}
+%
+\item[\rond]  Aout 2007 {\bf (PI)}:  Contournement d'un problme d'venements X expose 
+perdu - apparu avec des versions rcentes du serveur XFree ou le serveur X sur Linux
+ou une combinaison des deux. Rsultat, contenu non affich lors d'une cration de fentre
+suivi d'un ajout de PIBaseWidget (sauf PIImage) et plantage lors du click dans la fentre.
+Correction: Ajout de {\tt XFlush() + usleep(5000)} (5 $\mu$s). 
 \item[\rond]  Juin 2007 {\bf (PI/PIext)}:  Ajout des mthodes 
 {\tt PIGraphicAtt::ColNameToColor() , ColIndexToColor()} et possibilit d'utiliser le contenu
@@ -198,5 +219,5 @@
 {\tt NOMAdapter\_Image<T>  }
 \end{itemize}
-\item[ \rond] Janvier 2007  {\bf (PI)}:  modification des trac\'es des histogrammes PIHisto.
+\item[ \rond] Janvier 2007  {\bf (PIext)}:  modification des trac\'es des histogrammes PIHisto.
 La classe PIHisto prend en entr\'ee un wrapper P1DHistoWrapper.
 Les wrappers HistoWrapper et HistoErrWrapper sont cr\'ees.
@@ -217,5 +238,5 @@
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-\groupe{De V1.5 (Dec2002)  V2.0 (Sep2006) }
+\groupe{De V1.7 (Sep2003)  V2.0 (Sep2006) }
 \titre{BuildMgr} 
 \begin{itemize}
@@ -291,5 +312,5 @@
 \begin{itemize}
 \item[\rond] Ajout de la classe {\bf TimeStamp} pour la manipulation de date et heure - 
-calcul de duree. - Ajout du prog. test Tests/ttimestamp.cc (Mars 2003) 
+calcul de duree. - Ajout du prog. test Tests/ttimestamp.cc (Mars 2005) 
 \item[\rond] { \bf Segmented Data Block :}  \\
 Mars-Avril 2005: Introduction des classes similaires aux NDataBlock, mais permettant 
@@ -1235,10 +1256,13 @@
 dans ProgPI/fitsbtadapter.cc en utilisant le nouveau FITS - 
 Le menu OpenFits de PIStdImgApp utilise desormais ces commandes
+\item {\bf BUG } a corriger pour {\tt imagvav}: 
+La destruction de l'objet et/ou widget pascorrectement geres - 
+provoque des plantages lors de la sortie de l'application.
+\end{itemize}
+\soustitre{piapp multi-thread }
+\begin{itemize}
 \item[\rond] Avril 2005: Possibilit d'execution de commandes en threads separes, en
 ajoutant {\bf \&} en fin de ligne de commande.
 \item[\rond] Janvier 2004: Le multithreading a t mis en oeuvre dans piapp . 
-\item {\bf BUG } a corriger pour {\tt imagvav}: 
-La destruction de l'objet et/ou widget pascorrectement geres - 
-provoque des plantages lors de la sortie de l'application.
 
 \item[\rond] Extrait de {\tt cvs log pistdimgapp.cc } : 